package turgen.generator;

import java.io.Serializable;

public class PulseCrate implements Serializable {

    public int pilotTonePulseWidth=0;
    public int longPulseWidth=0;
    public int shortPulseWidth=0;
    public int syncPulseWidth=0;
    public int stopPulseWidth=0;
    public int baudRate=0;
    public String name;

    public String toString() {
        return name;
    }

    public PulseCrate getCopy() {
        PulseCrate c = new PulseCrate();
        c.pilotTonePulseWidth=pilotTonePulseWidth;
        c.longPulseWidth=longPulseWidth;
        c.shortPulseWidth=shortPulseWidth;
        c.syncPulseWidth=syncPulseWidth;
        c.stopPulseWidth=stopPulseWidth;
        c.baudRate=baudRate;
        c.name=name;
        return c;
    }
    
    /** Apply fine tuning PulseCrate
     * 
     * @param fc Fine tuning PulseCrate
     */
    public void applyFineTuning(PulseCrate fc) {
        
        pilotTonePulseWidth +=fc.pilotTonePulseWidth;
        longPulseWidth += fc.longPulseWidth;
        shortPulseWidth += fc.shortPulseWidth;
        syncPulseWidth += fc.syncPulseWidth;
        stopPulseWidth += fc.stopPulseWidth;
        
        if (pilotTonePulseWidth<2) pilotTonePulseWidth=2;
        if (longPulseWidth<2) longPulseWidth=2;
        if (shortPulseWidth<2) shortPulseWidth=2;
        if (syncPulseWidth<2) syncPulseWidth=2;
        if (stopPulseWidth<2) stopPulseWidth=2;
    }
    
    
}
